| Flutter Impeller |

Public Member Functions | List of all members
impeller::RoundRectGeometry Class Referencefinal

`#include <round_rect_geometry.h>`

Inheritance diagram for impeller::RoundRectGeometry:

## Public Member Functions
| RoundRectGeometry (const Rect &bounds, const Size &radii)
| ~RoundRectGeometry ()=default
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::shared_ptr< Geometry > | MakeFillPath (Path path, std::optional< Rect > inner_rect=std::nullopt)
static std::shared_ptr< Geometry > | MakeStrokePath (Path path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::shared_ptr< Geometry > | MakeCover ()
static std::shared_ptr< Geometry > | MakeRect (const Rect &rect)
static std::shared_ptr< Geometry > | MakeOval (const Rect &rect)
static std::shared_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::shared_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::shared_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::shared_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::shared_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)
Static Protected Member Functions inherited from impeller::Geometry
static GeometryResult | ComputePositionGeometry (const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)
static GeometryResult | ComputePositionUVGeometry (const Tessellator::VertexGenerator &generator, const Matrix &uv_transform, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 16 of file round_rect_geometry.h.

## Constructor & Destructor Documentation

## ◆ RoundRectGeometry()

impeller::RoundRectGeometry::RoundRectGeometry | ( | const Rect & | bounds,
|  | const Size & | radii
| ) |  |
| explicit

Definition at line 13 of file round_rect_geometry.cc.

14 : bounds_(bounds), radii_(radii) {}

## ◆ ~RoundRectGeometry()

impeller::RoundRectGeometry::~RoundRectGeometry | ( |  | ) |
| default

## Member Function Documentation

## ◆ CoversArea()

bool impeller::RoundRectGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| override virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 48 of file round_rect_geometry.cc.

49 {
50 if (!transform.IsTranslationScaleOnly()) {
51 return false;
52 }
53 bool flat_on_tb = bounds_.GetWidth() > radii_.width * 2;
54 bool flat_on_lr = bounds_.GetHeight() > radii_.height * 2;
55 if (!flat_on_tb && !flat_on_lr) {
56 return false;
57 }
58 // We either transform the bounds and delta-transform the radii,
59 // or we compute the vertical and horizontal bounds and then
60 // transform each. Either way there are 2 transform operations.
61 // We could also get a weaker answer by computing just the
62 // "inner rect" and only doing a coverage analysis on that,
63 // but this process will produce more culling results.
64 if (flat_on_tb) {
65 Rect vertical_bounds = bounds_.Expand(Size{-radii_.width, 0});
66 Rect coverage = vertical_bounds.TransformBounds(transform);
67 if (coverage.Contains(rect)) {
68 return true;
69 }
70 }
71 if (flat_on_lr) {
72 Rect horizontal_bounds = bounds_.Expand(Size{0, -radii_.height});
73 Rect coverage = horizontal_bounds.TransformBounds(transform);
74 if (coverage.Contains(rect)) {
75 return true;
76 }
77 }
78 return false;
79 }

References impeller::TRect< T >::Contains(), impeller::TRect< T >::Expand(), impeller::TRect< T >::GetHeight(), impeller::TRect< T >::GetWidth(), impeller::TSize< T >::height, impeller::Matrix::IsTranslationScaleOnly(), impeller::TRect< T >::TransformBounds(), and impeller::TSize< T >::width.

## ◆ IsAxisAlignedRect()

bool impeller::RoundRectGeometry::IsAxisAlignedRect | ( |  | ) | const
| override virtual

Reimplemented from impeller::Geometry.

Definition at line 81 of file round_rect_geometry.cc.

81 {
82 return false;
83 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/round_rect_geometry.h
- impeller/entity/geometry/round_rect_geometry.cc

impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:264
impeller::Size
TSize< Scalar > Size
Definition: size.h:137
impeller::TRect::GetHeight
constexpr Type GetHeight() const
Returns the height of the rectangle, equivalent to |GetSize().height|.
Definition: rect.h:175
impeller::TRect::GetWidth
constexpr Type GetWidth() const
Returns the width of the rectangle, equivalent to |GetSize().width|.
Definition: rect.h:171
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:488
impeller::TSize::width
Type width
Definition: size.h:22
impeller::TSize::height
Type height
Definition: size.h:23
impeller::TRect::Expand
constexpr TRect< T > Expand(T left, T top, T right, T bottom) const
Returns a rectangle with expanded edges. Negative expansion results in shrinking.
Definition: rect.h:373